AOZ Studio Beta - Bug #552

Font scaling on bitmapped (Amiga) fonts not working properly.
10/22/2020 08:12 AM - Brian Flanagan

Status: New Start date: 10/22/2020
Priority: Normal Due date:

Assignee: AQOZ Developers % Done: 0%
Category: Estimated time: 1:00 hour
Target version:

Affected version: 1.0 (u38)

Description

When the size is too much smaller than the original bitmap, the characters are too far apart horizontally.
When the size is too much larger than the original bitmap, the characters are too close together horizontally.

Example:

#manifest: "aoz"

famigaFont: "news" ' 23

#amigaFont: "2001" ' 8

#amigaFont: "ammolite" ' 10
#amigaFont: "courier" ' 11,13,15,18,24
#amigaFont: "garnet" ' 9,16
#amigaFont: "mFast" ' 20

#amigaFont: "peridot" ' 7

famigaFont: "times" ' 11,13,15,18,24
#amigaFont: "arial" ' 11,12,13,15,16,20,25,30,35,40
famigaFont: "diamond" ' 12, 20
#amigaFont: "helvetica" ' 9,11,13,15,18,24
#amigaFont: "onyx" ' 9

#amigaFont: "ruby" ' 8§8,12,15
famigaFont: "topaz" ' 11

#amigaFont: "pica" ' 32

famigaFont: "broadway" ' 16
famigaFont: "emerald" ' 17,20
#amigaFont: "lines" ' 21

#amigaFont: "opal" ' 9,12

#amigaFont: "sapphire" ' 14,19

Screen Open 0,1280,720,32,Lowres

Palette 0, SFFFFFF

Ink 1

Cls 0 : Curs Off : Flash Off

Data "helvetica", "emerald","lines", "sapphire", "news","2001", "ammolite", "garnet", "peridot", "onyx"
Data "pica", "broadway", "opal", "news", "courier", "mFast", "times", "arial", "diamond", "ruby", "topaz"

f=20 ' read 20 Amiga fonts
Dim £$ (f)
For fnt=0 to f-1

Read f$(fnt)

Next fnt
gap = 2
fnt = 0
skip = 34
Do

For fontHeight=8 to 48 step 4
cls O
Locate 0,0 : Print "Font: "+f$(fnt)+Str$ (fontHeight) +"px"
Set Font f$(fnt), fontHeight
startAt=fontHeight+gap+skip
Text
Text
Text
Text
Wait

0,startAt,

0, startAt+fontHeight+gap,
0,startAt+ (fontHeight+gap) *2,
0,startAt+ (fontHeight+gap) *3,
Key : Repeat Until InkeyS$=""

Next fontHeight

Inc fnt
Loop

If fnt=f Then fnt=0

"Font: "+f$ (fnt)+Str$ (fontHeight) +"px"
"In the beginning, God"

"created the heavens"

"and the earth."”

History

#1 - 01/14/2023 07:51 AM - Brian Flanagan

- Assignee set to AOZ Developers

- Affected version changed from Beta RC3 to 1.0 (u38)

| reported this problem about 2 years ago (in beta RC3). lt is still a problem.
Use the example program.
Press a key to cycle through the sizes.

The problem is that when the font height is scaled, the font width is not scaled accordingly.
Vertically, they appear to scale properly. The scale does not change horizontally.
